--	Health bar script

--	(made by Alistaire)

--[[

Only configuration is HB_hpbar (under this comment)

----

HB_hpbar:

Value for healthbar movement

	HB_hpbar			Manner

		1		-		Healthbar moves from sides to middle 	(Low CPU usage)

		2		-		Healthbar moves from left to right 		(Higher CPU usage)

		3		-		Healthbar moves from right to left		(Higher CPU usage)

--]]

HB_hpbar = 2

P = 'gfx/Hpbar/'

function A()
	local c = {}
	for i = 1, 32 do
		c[i] = 0
	end
	return c
end

HB_bar 			= 		A()
HB_overlay 		= 		A()

addhook('collect', 	'HB_collect')
addhook('die', 		'HB_die')
addhook('hit', 		'HB_hit')
addhook('move', 	'HB_move')
addhook('spawn', 	'HB_spawn')

function HB_collect(id, iid)
	if iid == 64 or 65 then
		HB_hudupdate(id)
	end
end

function HB_die(id)
	freeimage(HB_bar[id])
	freeimage(HB_overlay[id])
end

function HB_hit(id, hpdmg)
	HB_hudupdate(id, hpdmg)
end

function HB_hudupdate(id, hpdmg)
	if hpdmg then
		d = hpdmg
	else
		d = 0
	end
	local a = (player(id, 'health') - d) / player(id, 'maxhealth')
	local c = a * 255
	local b = 255 - c
	imagescale(HB_bar[id], a, 1)
	imagecolor(HB_bar[id], b, c, 0)
end

function HB_hudsetup(i)
	function hudsetup(id)
		local x = player(id, 'x')
		local y = player(id, 'y')
		if HB_hpbar == 1 then
			q = 132 + id
			r = 0
			s = 1
			t = 0
		elseif HB_hpbar >= 2 then
			q = 1
			if HB_hpbar == 2 then
				r = x + 32
			else
				r = x - 32
			end
			s = y
			t = x
		end
		HB_bar[id] = image(P..'Hpbar'..HB_hpbar..'.png', r, s, q)
		HB_overlay[id] = image(P..'Overlay'..HB_hpbar..'.png', t, s, q)
		HB_hudupdate(id)
	end
	if i then
		hudsetup(i)
	else
		for z = 1, 32 do
			hudsetup(z)
		end
	end
end

function HB_move(id, x, y)
	if HB_hpbar == 2 then
		tween_move(HB_bar[id], 0, player(id, 'x') + 32, player(id, 'y'))
		tween_move(HB_overlay[id], 0, player(id, 'x'), player(id, 'y'))
	elseif HB_hpbar == 3 then
		tween_move(HB_bar[id], 0, player(id, 'x') - 32, player(id, 'y'))
		tween_move(HB_overlay[id], 0, player(id, 'x'), player(id, 'y'))
	end
end

function HB_spawn(id)
	HB_hudsetup(id)
end